<template>
  <a-page-header :title="getPageTitle()" @back="() => $router.go(-1)">
    <a-card :bordered="false" :body-style="{ padding: '16px' }">
      <ele-pro-table
        ref="tableRef"
        row-key="id"
        :columns="columns"
        :datasource="datasource"
        :customRow="customRow"
        tool-class="ele-toolbar-form"
        class="sys-org-table"
        v-model:selection="selection"
      >
        <template #toolbar>
          <search
            @search="reload"
            :selection="selection"
            @add="openEdit"
            @remove="removeBatch"
            @batchMove="openMove"
            @done="reload"
          />
        </template>
        <template #bodyCell="{ column, record }">
          <template v-if="column.key === 'goodsId'">
            <div>{{ record.goodsName }}</div>
            <div class="text-gray-300" v-if="record.nickName"
              >领取人：{{ record.userId }}</div
            >
            <div class="text-gray-300" v-if="record.operatorUserId"
              >核销人：{{ record.operatorUserId }}</div
            >
          </template>
          <template v-if="column.key === 'image'">
            <a-image :src="record.image" :width="50" />
          </template>
          <template v-if="column.key === 'status'">
            <a-space>
              <a-tag v-if="record.userId == 0">未领取</a-tag>
              <a-tag
                v-if="record.userId > 0 && record.status === 0"
                color="green"
                >已领取</a-tag
              >
              <a-tag v-if="record.status === 1" color="green">已使用</a-tag>
              <a-tag v-if="record.status === 2" color="red">已失效</a-tag>
            </a-space>
          </template>
          <template v-if="column.key === 'createTime'">
            <div v-if="record.createTime"
              >创建时间：{{ record.createTime }}</div
            >
            <div v-if="record.takeTime" class="text-green-500"
              >领取时间：{{ record.takeTime }}</div
            >
            <div v-if="record.verificationTime" class="text-purple-500"
              >核销时间：{{ record.verificationTime }}</div
            >
          </template>
          <template v-if="column.key === 'action'">
            <a-space>
              <a @click="openEdit(record)">修改</a>
              <a-divider type="vertical" />
              <a-popconfirm
                title="确定要删除此记录吗？"
                @confirm="remove(record)"
              >
                <a class="ele-text-danger">删除</a>
              </a-popconfirm>
            </a-space>
          </template>
        </template>
      </ele-pro-table>
    </a-card>

    <!-- 编辑弹窗 -->
    <ShopGiftEdit v-model:visible="showEdit" :data="current" @done="reload" />
  </a-page-header>
</template>

<script lang="ts" setup>
  import { createVNode, ref } from 'vue';
  import { message, Modal } from 'ant-design-vue';
  import { ExclamationCircleOutlined } from '@ant-design/icons-vue';
  import type { EleProTable } from 'ele-admin-pro';
  import type {
    DatasourceFunction,
    ColumnItem
  } from 'ele-admin-pro/es/ele-pro-table/types';
  import Search from './components/search.vue';
  import { getPageTitle } from '@/utils/common';
  import ShopGiftEdit from './components/shopGiftEdit.vue';
  import {
    pageShopGift,
    removeShopGift,
    removeBatchShopGift
  } from '@/api/shop/shopGift';
  import type { ShopGift, ShopGiftParam } from '@/api/shop/shopGift/model';

  // 表格实例
  const tableRef = ref<InstanceType<typeof EleProTable> | null>(null);

  // 表格选中数据
  const selection = ref<ShopGift[]>([]);
  // 当前编辑数据
  const current = ref<ShopGift | null>(null);
  // 是否显示编辑弹窗
  const showEdit = ref(false);
  // 是否显示批量移动弹窗
  const showMove = ref(false);
  // 加载状态
  const loading = ref(true);

  // 表格数据源
  const datasource: DatasourceFunction = ({
    page,
    limit,
    where,
    orders,
    filters
  }) => {
    if (filters) {
      where.status = filters.status;
    }
    return pageShopGift({
      ...where,
      ...orders,
      page,
      limit
    });
  };

  // 表格列配置
  const columns = ref<ColumnItem[]>([
    {
      title: 'ID',
      dataIndex: 'id',
      key: 'id',
      align: 'center',
      width: 90
    },
    {
      title: '名称',
      dataIndex: 'name',
      key: 'name',
      align: 'center'
    },
    {
      title: '秘钥',
      dataIndex: 'code',
      key: 'code',
      align: 'center'
    },
    {
      title: '商品',
      dataIndex: ['goods', 'name'],
      key: 'goodsId',
      align: 'center'
    },
    {
      title: '状态',
      dataIndex: 'status',
      key: 'status',
      align: 'center',
      width: 170
    },
    {
      title: '创建时间',
      dataIndex: 'createTime',
      key: 'createTime',
      align: 'center',
      sorter: true
    },
    {
      title: '操作',
      key: 'action',
      width: 180,
      fixed: 'right',
      align: 'center',
      hideInSetting: true
    }
  ]);

  /* 搜索 */
  const reload = (where?: ShopGiftParam) => {
    selection.value = [];
    tableRef?.value?.reload({ where: where });
  };

  /* 打开编辑弹窗 */
  const openEdit = (row?: ShopGift) => {
    current.value = row ?? null;
    showEdit.value = true;
  };

  /* 打开批量移动弹窗 */
  const openMove = () => {
    showMove.value = true;
  };

  /* 删除单个 */
  const remove = (row: ShopGift) => {
    const hide = message.loading('请求中..', 0);
    removeShopGift(row.id)
      .then((msg) => {
        hide();
        message.success(msg);
        reload();
      })
      .catch((e) => {
        hide();
        message.error(e.message);
      });
  };

  /* 批量删除 */
  const removeBatch = () => {
    if (!selection.value.length) {
      message.error('请至少选择一条数据');
      return;
    }
    Modal.confirm({
      title: '提示',
      content: '确定要删除选中的记录吗?',
      icon: createVNode(ExclamationCircleOutlined),
      maskClosable: true,
      onOk: () => {
        const hide = message.loading('请求中..', 0);
        removeBatchShopGift(selection.value.map((d) => d.id))
          .then((msg) => {
            hide();
            message.success(msg);
            reload();
          })
          .catch((e) => {
            hide();
            message.error(e.message);
          });
      }
    });
  };

  /* 查询 */
  const query = () => {
    loading.value = true;
  };

  /* 自定义行属性 */
  const customRow = (record: ShopGift) => {
    return {
      // 行点击事件
      onClick: () => {
        // console.log(record);
      },
      // 行双击事件
      onDblclick: () => {
        openEdit(record);
      }
    };
  };

  query();
</script>

<script lang="ts">
  export default {
    name: 'ShopGift'
  };
</script>

<style lang="less" scoped></style>
